/***************************************************************************
                          choosefuncdlg.h  -  description
                             -------------------
    begin                : Mit Jul 23 2003
    copyright            : (C) 2017 by Werner Stille
    email                : kpl@werner-stille.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHOOSEFUNCDLG_H
#define CHOOSEFUNCDLG_H

#include <QDialog>

class QDialogButtonBox;
class QLineEdit;
class QListWidget;
class QListWidgetItem;
/**
  * Choose function dialog class. Provides a dialog for the selection
  * of a function from list of functions in a shared library.
  * @author Werner Stille
  */
class ChooseFuncDlg : public QDialog
{
  Q_OBJECT
public:
  /**
   * Constructor.
   * @param parent pointer to parent widget.
   * @param names list of function names.
   * @param func pointer to QLineEdit widget for the function name.
   */
  ChooseFuncDlg(QWidget* parent, const QStringList& names, QLineEdit* func);
  /** Destructor. */
  ~ChooseFuncDlg();

protected:
  QLineEdit* func;
  QListWidget* funcList;
  QDialogButtonBox* buttonBox;

protected slots:
  /** Reimplemented from QDialog. */
  virtual void accept();
  /** Enables Ok button. */
  void slotEdited();
  /**
   * Accepts selection and leaves the dialog.
   * @param item list item of selected function
   */
  void slotList(QListWidgetItem* item);
};

#endif
