/***************************************************************************
                          editdlg.cpp  -  description
                             -------------------
    begin                : Tue Jul 24 2001
    copyright            : (C) 2017 by Werner Stille
    email                : kpl@werner-stille.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <QDialogButtonBox>
#include <QLayout>
#include <QPushButton>
#include <QTextEdit>
#include <KLocalizedString>
#include "editdlg.h"

EditDlg::EditDlg(QWidget* parent, QString* str, int ts) :
 QDialog(parent), s(str)
{
  setWindowTitle(i18n("Edit"));
  QVBoxLayout* vbox = new QVBoxLayout(this);
  vbox->addWidget(edit = new QTextEdit);
  if (ts)
    edit->setTabStopWidth(ts * edit->fontMetrics().width(QChar('0')));
  edit->setPlainText(*s);
  vbox->addWidget(buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok |
                                                   QDialogButtonBox::Apply |
                                                   QDialogButtonBox::Cancel));
  buttonBox->button(QDialogButtonBox::Apply)->setEnabled(false);
  buttonBox->button(QDialogButtonBox::Ok)->setEnabled(false);
  resize(260, 260);
  connect(edit, SIGNAL(textChanged()), SLOT(slotEdited()));
  connect(buttonBox, SIGNAL(clicked(QAbstractButton*)),
          SLOT(slotButtonClicked(QAbstractButton*)));
}

EditDlg::~EditDlg()
{
}

void EditDlg::slotButtonClicked(QAbstractButton* button)
{
  int id = buttonBox->standardButton(button);
  switch (id) {
    case QDialogButtonBox::Apply:
      buttonBox->button(QDialogButtonBox::Apply)->setEnabled(false);
      buttonBox->button(QDialogButtonBox::Ok)->setEnabled(false);
    case QDialogButtonBox::Ok:
      *s = edit->toPlainText();
      if (id == QDialogButtonBox::Ok)
        accept();
      else
        emit applyClicked();
      break;
    case QDialogButtonBox::Cancel:
      reject();
  }
}

void EditDlg::slotEdited()
{
  buttonBox->button(QDialogButtonBox::Apply)->setEnabled(true);
  buttonBox->button(QDialogButtonBox::Ok)->setEnabled(true);
}
