/***************************************************************************
                          scalebardlg.h  -  description
                             -------------------
    begin                : Sam Jun 14 2003
    copyright            : (C) 2017 by Werner Stille
    email                : kpl@werner-stille.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCALEBARDLG_H
#define SCALEBARDLG_H

#include "decodlg.h"

class QButtonGroup;
class QDoubleSpinBox;
class QLineEdit;
class ScaleBarItem;

/**
  * Scale bar settings dialog class. Provides a dialog for the settings
  * of a scale bar decoration item.
  * @author Werner Stille
  */
class ScaleBarDlg : public DecoDlg
{
  Q_OBJECT
public:
  /**
   * Constructor.
   * @param parent pointer to parent widget.
   * @param model pointer to KplDoc model object.
   * @param si pointer to scale bar item.
   * @param pos dialog position.
   */
  ScaleBarDlg(QWidget* parent, KplDoc* model, ScaleBarItem* si,
              const QPoint& pos);
  /** Destructor. */
  ~ScaleBarDlg();

protected:
  ScaleBarItem* si;
  QLineEdit* eText;
  QButtonGroup* bg;
  QDoubleSpinBox* eLen;

protected slots:
  /**
   * Handles button clicks.
   * @param button pointer to button.
   */
  void slotButtonClicked(QAbstractButton* button);
  /** Displays dialog to edit text. */
  void slotEditText();
};

#endif
